/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.fushi.FushiManager
 *  fire.pb.lock.SAddLockSuc
 *  fire.pb.lock.SCancelLockSuc
 *  fire.pb.lock.SChangePasswordSuc
 *  fire.pb.lock.SForceUnlockSuc
 *  fire.pb.lock.SLockInfo
 *  fire.pb.lock.SUnlockSuc
 *  fire.pb.lock.SUpdateLockInfo
 *  fire.pb.talk.MessageMgr
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.Pod
 *  xbean.RoleLockInfo
 *  xtable.Rolesafelock
 */
package fire.pb.lock.service;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.fushi.FushiManager;
import fire.pb.lock.SAddLockSuc;
import fire.pb.lock.SCancelLockSuc;
import fire.pb.lock.SChangePasswordSuc;
import fire.pb.lock.SForceUnlockSuc;
import fire.pb.lock.SLockInfo;
import fire.pb.lock.SUnlockSuc;
import fire.pb.lock.SUpdateLockInfo;
import fire.pb.talk.MessageMgr;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.Pod;
import xbean.RoleLockInfo;
import xtable.Rolesafelock;

public class LockService {
    private static final LockService instance = new LockService();

    public static LockService getInstance() {
        return instance;
    }

    private LockService() {
    }

    public boolean checkLockStatus(long roleId) {
        RoleLockInfo info = Rolesafelock.get((Long)roleId);
        if (info == null) {
            info = Pod.newRoleLockInfo();
            info.setPassword("");
            info.setUnlocktime(0L);
            info.setForceunlocktime(0L);
            info.setErrortimes(0);
            info.setFullerrortime(0L);
            Rolesafelock.insert((Long)roleId, (RoleLockInfo)info);
            return true;
        }
        if (info.getPassword().equals("")) {
            return true;
        }
        long now = System.currentTimeMillis();
        if (info.getForceunlocktime() > 0L && now - info.getForceunlocktime() >= 604800000L) {
            info.setForceunlocktime(0L);
            info.setPassword("");
            info.setUnlocktime(0L);
            MessageMgr.sendMsgNotify((long)roleId, (int)145382, null);
            return true;
        }
        return now - info.getUnlocktime() <= 10800000L;
    }

    public void updateLockStatus(long roleId) {
        long now;
        RoleLockInfo info = Rolesafelock.get((Long)roleId);
        if (info == null) {
            info = Pod.newRoleLockInfo();
            info.setPassword("");
            info.setUnlocktime(0L);
            info.setForceunlocktime(0L);
            info.setErrortimes(0);
            info.setFullerrortime(0L);
            Rolesafelock.insert((Long)roleId, (RoleLockInfo)info);
        }
        if ((now = System.currentTimeMillis()) - info.getUnlocktime() <= 10800000L) {
            info.setUnlocktime(0L);
        }
        if (info.getForceunlocktime() > 0L && now - info.getForceunlocktime() >= 604800000L) {
            info.setForceunlocktime(0L);
            info.setPassword("");
            info.setUnlocktime(0L);
            MessageMgr.sendMsgNotify((long)roleId, (int)145382, null);
        }
    }

    public boolean resetForceUnlock(RoleLockInfo info, long time, long roleId) {
        if (info.getForceunlocktime() > 0L && time - info.getForceunlocktime() >= 604800000L) {
            info.setForceunlocktime(0L);
            info.setPassword("");
            info.setUnlocktime(0L);
            MessageMgr.sendMsgNotify((long)roleId, (int)145382, null);
            return true;
        }
        return false;
    }

    public void addLock(RoleLockInfo info, long roleId, String password) {
        long now = System.currentTimeMillis();
        this.resetForceUnlock(info, now, roleId);
        if (!info.getPassword().equals("")) {
            return;
        }
        info.setPassword(password);
        SUpdateLockInfo lockInfo = new SUpdateLockInfo(1);
        Procedure.psendWhileCommit((long)roleId, (Protocol)lockInfo);
        MessageMgr.sendMsgNotify((long)roleId, (int)145349, null);
        SAddLockSuc msg = new SAddLockSuc();
        Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
    }

    public void cancelLock(RoleLockInfo info, String password, long roleId) {
        long now = System.currentTimeMillis();
        boolean flag = this.resetForceUnlock(info, now, roleId);
        if (info.getPassword().equals("")) {
            if (flag) {
                SLockInfo msg = new SLockInfo(0);
                Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
            }
            return;
        }
        if (info.getErrortimes() >= 5) {
            if (now - info.getFullerrortime() <= 600000L) {
                MessageMgr.sendMsgNotify((long)roleId, (int)145361, null);
                return;
            }
            info.setErrortimes(0);
        }
        if (!info.getPassword().equals(password)) {
            info.setErrortimes(info.getErrortimes() + 1);
            if (info.getErrortimes() >= 5) {
                info.setFullerrortime(now);
            }
            MessageMgr.sendMsgNotify((long)roleId, (int)145358, null);
            return;
        }
        info.setPassword("");
        info.setUnlocktime(0L);
        info.setForceunlocktime(0L);
        info.setErrortimes(0);
        MessageMgr.sendMsgNotify((long)roleId, (int)145357, null);
        SUpdateLockInfo lockInfo = new SUpdateLockInfo(0);
        Procedure.psendWhileCommit((long)roleId, (Protocol)lockInfo);
        SCancelLockSuc msg = new SCancelLockSuc();
        Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
    }

    public void unlock(RoleLockInfo info, String password, long roleId) {
        long now = System.currentTimeMillis();
        boolean flag = this.resetForceUnlock(info, now, roleId);
        if (info.getPassword().equals("")) {
            if (flag) {
                SLockInfo msg = new SLockInfo(0);
                Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
            }
            return;
        }
        if (info.getErrortimes() >= 5) {
            if (now - info.getFullerrortime() <= 600000L) {
                MessageMgr.sendMsgNotify((long)roleId, (int)145359, null);
                return;
            }
            info.setErrortimes(0);
        }
        if (!info.getPassword().equals(password)) {
            info.setErrortimes(info.getErrortimes() + 1);
            if (info.getErrortimes() >= 5) {
                info.setFullerrortime(now);
            }
            MessageMgr.sendMsgNotify((long)roleId, (int)145352, null);
            return;
        }
        info.setUnlocktime(now);
        if (info.getForceunlocktime() > 0L) {
            info.setForceunlocktime(0L);
        }
        info.setErrortimes(0);
        MessageMgr.sendMsgNotify((long)roleId, (int)145351, null);
        SUpdateLockInfo lockInfo = new SUpdateLockInfo(2);
        Procedure.psendWhileCommit((long)roleId, (Protocol)lockInfo);
        SUnlockSuc msg = new SUnlockSuc();
        Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
    }

    public void forceUnlock(RoleLockInfo info, long roleId, int userId) {
        long now = System.currentTimeMillis();
        boolean flag = this.resetForceUnlock(info, now, roleId);
        if (info.getPassword().equals("")) {
            if (flag) {
                SLockInfo msg = new SLockInfo(0);
                Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
            }
            return;
        }
        if (info.getForceunlocktime() > 0L) {
            MessageMgr.sendMsgNotify((long)roleId, (int)145362, null);
            return;
        }
        if (!FushiManager.subFushiFromUser((int)userId, (long)roleId, (int)200, (int)0, (int)0, (int)1318, (YYLoggerTuJingEnum)YYLoggerTuJingEnum.tujing_Value_forceunlock, (boolean)false)) {
            MessageMgr.sendMsgNotify((long)roleId, (int)145381, null);
            return;
        }
        info.setForceunlocktime(now);
        MessageMgr.sendMsgNotify((long)roleId, (int)145372, null);
        SUpdateLockInfo lockInfo = this.getSUpdateLockInfo(info, now);
        Procedure.psendWhileCommit((long)roleId, (Protocol)lockInfo);
        SForceUnlockSuc msg = new SForceUnlockSuc();
        Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
    }

    public void changePassword(RoleLockInfo info, String oldPassword, String newPassword, long roleId) {
        long now = System.currentTimeMillis();
        boolean flag = this.resetForceUnlock(info, now, roleId);
        if (info.getPassword().equals("")) {
            if (flag) {
                SLockInfo msg = new SLockInfo(0);
                Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
            }
            return;
        }
        if ("".equals(newPassword)) {
            MessageMgr.sendMsgNotify((long)roleId, (int)145345, null);
            return;
        }
        if (info.getErrortimes() >= 5) {
            if (now - info.getFullerrortime() <= 600000L) {
                MessageMgr.sendMsgNotify((long)roleId, (int)145360, null);
                return;
            }
            info.setErrortimes(0);
        }
        if (!info.getPassword().equals(oldPassword)) {
            info.setErrortimes(info.getErrortimes() + 1);
            if (info.getErrortimes() >= 5) {
                info.setFullerrortime(now);
            }
            MessageMgr.sendMsgNotify((long)roleId, (int)145354, null);
            return;
        }
        info.setPassword(newPassword);
        info.setErrortimes(0);
        MessageMgr.sendMsgNotify((long)roleId, (int)145356, null);
        SUpdateLockInfo lockInfo = this.getSUpdateLockInfo(info, now);
        Procedure.psendWhileCommit((long)roleId, (Protocol)lockInfo);
        SChangePasswordSuc msg = new SChangePasswordSuc();
        Procedure.psendWhileCommit((long)roleId, (Protocol)msg);
    }

    public SLockInfo getSLockInfo(RoleLockInfo info, long time) {
        int status = -1;
        status = info.getPassword().equals("") ? 0 : (time - info.getUnlocktime() >= 10800000L ? 1 : 2);
        SLockInfo msg = new SLockInfo(status);
        return msg;
    }

    public void clearUnlockTime(long roleId) {
        RoleLockInfo info = Rolesafelock.get((Long)roleId);
        if (info == null) {
            info = Pod.newRoleLockInfo();
            info.setPassword("");
            info.setUnlocktime(0L);
            info.setForceunlocktime(0L);
            info.setErrortimes(0);
            info.setFullerrortime(0L);
            Rolesafelock.insert((Long)roleId, (RoleLockInfo)info);
        }
        info.setUnlocktime(0L);
    }

    public SUpdateLockInfo getSUpdateLockInfo(RoleLockInfo info, long time) {
        int status = -1;
        status = info.getPassword().equals("") ? 0 : (time - info.getUnlocktime() >= 10800000L ? 1 : 2);
        SUpdateLockInfo msg = new SUpdateLockInfo(status);
        return msg;
    }
}

